import jsonpatch
import jsonschema
import json

import os,sys



def PYHF_to_HA_ATLAS_SUSY_2019_09_offshell(cutname):
    # SRlow_0Jb_cuts -> SRlow_0j etc
    outname=cutname[:-5]
    outname=outname.replace('J','j')
    return outname



if len(sys.argv) < 3:
    print("Need to specify <AnalysisName> <Background json>")

try:
    analysisname=sys.argv[1]
    bkgname=sys.argv[2]
    print(bkgname)
    with open(bkgname,'r') as IFJ:
        json_in=json.load(IFJ)
except:
    print("Could not open background json file")
    raise SystemExit



#IF=open('pyhf_regions.txt','r')

outdict={}

for ch in json_in['channels']:

    if ch['name'][:2] != 'SR':
        print("non SR channel: "+ch['name'])
        continue

    print("Found signal channel "+ch['name'])
    ssize=len(ch['samples'][0]['data'])
    print(f"Contains {ssize} samples")
    cutname=ch['name']
    if analysisname=='ATLAS_SUSY_2019_09_OFFSHELL':
        haname=PYHF_to_HA_ATLAS_SUSY_2019_09_offshell(cutname)
    else:
        haname=cutname

    if ssize > 1:
        for nn in range(ssize):
            haname=cutname+'_'+str(nn)
            outdict[haname] = haname
    else:
        outdict[cutname]=haname
    #outdict[cutname]=haname



AnalysisDict={}
AnalysisDict['Analysis']=analysisname
AnalysisDict['Lumi']=139.0
AnalysisDict['Type']='pyhf'
AnalysisDict['Background File']=bkgname
AnalysisDict['Region Dictionary'] = outdict

#with open('my_region_dict.json','w') as OF:
#    json.dump(outdict,OF,indent=4)

with open('%s_info.json'%analysisname,'w') as OF:
    json.dump(AnalysisDict,OF,indent=4)