#include "Analyses/ATLAS_EXOT_2018_06.h"
#include "Analyses/ATLAS_SUSY_2017_04_2body.h"
#include "Analyses/ATLAS_SUSY_2017_04_3body.h"
#include "Analyses/ATLAS_SUSY_2018_16.h"
#include "Analyses/ATLAS_SUSY_2019_08.h"
#include "Analyses/ATLAS_SUSY_2019_09_offshell.h"
#include "Analyses/ATLAS_SUSY_2019_09_onshell.h"
#include "Analyses/CMS_EXO_20_004.h"
#include "Analyses/DT_CMS.h"
#include "Analyses/HSCP_ATLAS.h"


// Here we use macros to set up the list of all analyses
// and functions to check whether to run them. Sadly we can't
// also generate the include lines above. 
// However, deleting an entry from here will completely disable the analysis;
// we also have settings at runtime to do that on a per-run basis.

#define MAP_ONNX_ANALYSES(F) 

#define MAP_ANALYSES(F) \
F(ATLAS_EXOT_2018_06)\
F(ATLAS_SUSY_2017_04_2body)\
F(ATLAS_SUSY_2017_04_3body)\
F(ATLAS_SUSY_2018_16)\
F(ATLAS_SUSY_2019_08)\
F(ATLAS_SUSY_2019_09_offshell)\
F(ATLAS_SUSY_2019_09_onshell)\
F(CMS_EXO_20_004)\
F(DT_CMS)\
F(HSCP_ATLAS)
