#pragma once

#include <cassert>
#include <cstdlib>
#include <cstddef>
#include <type_traits>

#include <random>
#include <cfloat> // for DBL_MAX


#include "HepMC/IO_BaseClass.h"
#include "HepMC/IO_GenEvent.h"
#include "HepMC/GenEvent.h"
#include "HepMC/Units.h"


#include "heputil.h"

#include "smearing.h"
#include "fastjet/tools/GridMedianBackgroundEstimator.hh"



#include "Detectors/General_HEPMC.h"
#include "Detectors/Default_HEPMC.h"
#include "Detectors/ATLAS_HEPMC.h"

//#include "Detectors/TEST_Pythia.h"
//#include "Detectors/ATLAS_GAMBIT_Pythia.h"

using namespace std;







std::map<std::string, std::function<void(HEP::Event &OutEvt, HepMC::GenEvent* evt, int npileups, std::vector<HEP::PileupEvent*> &pileups, std::mt19937 &engine)>> hepmcFillMap =
//std::map<std::string, std::function<void(HEP::Event &OutEvt, HepMC::GenEvent* evt, SettingsContainer &runsettings, std::vector<HEP::PileupEvent*> &pileups, std::mt19937 &engine)>> hepmcFillMap =
{ 
  {"DEFAULT", filleventHEPMC},
  {"ATLAS",filleventHEPMC_ATLAS},
  {"FATJET",filleventHEPMC_FatJet}
};


//std::string 





