#pragma once

#include <cassert>
#include <cstdlib>
#include <cstddef>
#include <type_traits>

#include <random>
#include <cfloat> // for DBL_MAX

//#include "time.h"
#include <chrono>

#include "heputil.h"
#include "Pythia8/Pythia.h"
#include "fastjet/PseudoJet.hh"
#include "fastjet/ClusterSequence.hh"

#include "fastjet/tools/GridMedianBackgroundEstimator.hh"

#include "Pythia8Plugins/CombineMatchingInput.h"
#include "Pythia8Plugins/aMCatNLOHooks.h"

#include "smearing.h"
//#include "running.h"

#include <iomanip>


#include "Detectors/General_Pythia.h"
#include "Detectors/Default_Pythia.h"
#include "Detectors/ATLAS_Pythia.h"
//#include "Detectors/TEST_Pythia.h"
//#include "Detectors/ATLAS_GAMBIT_Pythia.h"

using namespace std;

std::map<std::string, std::function<void(HEP::Event&, Pythia8::Event&, double, int, std::vector<HEP::PileupEvent*>&, std::mt19937&)>> pythiaFillMap =
//std::map<std::string, std::function<void(HEP::Event&, Pythia8::Event&, double, SettingsContainer&, std::vector<HEP::PileupEvent*>&, std::mt19937&)>> pythiaFillMap =
{ 
  {"DEFAULT", filleventPYTHIA}, 
  {"ATLAS", filleventPYTHIA_ATLAS},
  {"FATJET",filleventPYTHIA_FatJet}
  //,
  //{"TEST", filleventPYTHIA_TEST},
  //{"ATLAS_GAMBIT", filleventPYTHIA_ATLAS_GAMBIT}
};



