#ifdef ONNXPATH
#pragma once

#include <cmath>
#include <ctype.h>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <string>
#include <algorithm>  // for find
#include <cfloat> // for DBL_MAX
#include "onnxruntime_cxx_api.h"
#ifndef HEPDATAINCLUDEDIR
#define HEPDATAINCLUDEDIR ""
#endif


using namespace std;



class HEPONNX 
{
    private:
        Ort::Env* _env;
        Ort::Session* _session;
        Ort::AllocatorWithDefaultOptions allocator;
        std::vector<Ort::AllocatedStringPtr> input_names_ptr;
        
         std::vector<int64_t> input_node_dims;

        std::vector<Ort::AllocatedStringPtr> output_names_ptr;
        
         std::vector<int64_t> output_node_dims;
    public: 

    HEPONNX() {};
  ~HEPONNX();

    
  HEPONNX(std::string filename);
  
  void addonnx(std::string filename);

  float get_result(std::vector<double> &nn_inputs); 



    size_t input_tensor_size; 
  std::vector<const char*> input_node_names;
        size_t num_input_nodes;    
        size_t output_tensor_size;  
 std::vector<const char*> output_node_names;
        size_t num_output_nodes;     

};

#endif
