#pragma once
/*

Routines for computing various kinematic variables of use

*/

#include "heputil.h"
#include "math.h"


/* 
double mct_330   (const LorentzTransverseVector& a, 
		    const LorentzTransverseVector& b) {
    const double mctsq = mct_330_Sq(a, b);
    // if less than zero, this is only evidence of inexact maths:
    if (mctsq<=0) {
      return 0;
    } else {
      return sqrt(mctsq);
    }
  }
  
  double mct_330_Sq(const LorentzTransverseVector& a,  
		    const LorentzTransverseVector& b) {
    return a.masssq() + b.masssq() + 2.0*a.contralinearDot(b);
  }

*/


namespace HEP {
  

/*
double mTcalc(MALorentzVector &v1, MALorentzVector &v2)
{
  //  m_T^2(p_1, p_2) =& m_1^2 + m_2^2 + 2 m_T^{(1)} m_T^{(2)} - 2 |p_T^{(1)}| |p_T^{(2)}| \cos \phi_{12} 

  
  
  return sqrt(v1.M2()+v2.M2() + 2.0*mT(v1)*mT(v2) - 2.0*v1.Pt()*v2.Pt()*cos(v1.DeltaPhi(v2)));

};
*/

/*
// we only use mTcalc for leptonp and pTmiss so fudge it
double mTcalc(MALorentzVector &v1, MALorentzVector &v2)
{
  //  m_T^2(p_1, p_2) =& m_1^2 + m_2^2 + 2 m_T^{(1)} m_T^{(2)} - 2 |p_T^{(1)}| >
  return sqrt(v1.M2() + 2.0*mT(v1)*v2.Pt() - 2.0*v1.Pt()*v2.Pt()*cos(v1.DeltaPhi(v2)));


};
*/

/*   mT is defined in Vectors.h
double mT(MALorentzVector &v1)
{
  return sqrt(v1.M2() + v1.Perp2());
}
*/


double mCT2(const HEP::P4 &v1, const HEP::P4 &v2);

double mCT(const HEP::P4 &v1, const HEP::P4 &v2);




//double HTjets(HEP::Event* event);

template<typename T1> double HT(std::vector<T1*> v1)    // should be a vector of something that has the pT() method
{
    double ht=0.0;

    for(auto tv : v1)
    {
        ht += tv->pT();
    }
    return ht;

}



};
